// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from automotive_platform_msgs:msg/AdaptiveCruiseControlCommand.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/detail/adaptive_cruise_control_command__rosidl_typesupport_fastrtps_cpp.hpp"
#include "automotive_platform_msgs/msg/detail/adaptive_cruise_control_command__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace std_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const std_msgs::msg::Header &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  std_msgs::msg::Header &);
size_t get_serialized_size(
  const std_msgs::msg::Header &,
  size_t current_alignment);
size_t
max_serialized_size_Header(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace std_msgs


namespace automotive_platform_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
cdr_serialize(
  const automotive_platform_msgs::msg::AdaptiveCruiseControlCommand & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.header,
    cdr);
  // Member: msg_counter
  cdr << ros_message.msg_counter;
  // Member: set_speed
  cdr << ros_message.set_speed;
  // Member: set
  cdr << ros_message.set;
  // Member: resume
  cdr << ros_message.resume;
  // Member: cancel
  cdr << ros_message.cancel;
  // Member: speed_up
  cdr << ros_message.speed_up;
  // Member: slow_down
  cdr << ros_message.slow_down;
  // Member: further
  cdr << ros_message.further;
  // Member: closer
  cdr << ros_message.closer;
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  automotive_platform_msgs::msg::AdaptiveCruiseControlCommand & ros_message)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.header);

  // Member: msg_counter
  cdr >> ros_message.msg_counter;

  // Member: set_speed
  cdr >> ros_message.set_speed;

  // Member: set
  cdr >> ros_message.set;

  // Member: resume
  cdr >> ros_message.resume;

  // Member: cancel
  cdr >> ros_message.cancel;

  // Member: speed_up
  cdr >> ros_message.speed_up;

  // Member: slow_down
  cdr >> ros_message.slow_down;

  // Member: further
  cdr >> ros_message.further;

  // Member: closer
  cdr >> ros_message.closer;

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
get_serialized_size(
  const automotive_platform_msgs::msg::AdaptiveCruiseControlCommand & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: header

  current_alignment +=
    std_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.header, current_alignment);
  // Member: msg_counter
  {
    size_t item_size = sizeof(ros_message.msg_counter);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: set_speed
  {
    size_t item_size = sizeof(ros_message.set_speed);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: set
  {
    size_t item_size = sizeof(ros_message.set);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: resume
  {
    size_t item_size = sizeof(ros_message.resume);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: cancel
  {
    size_t item_size = sizeof(ros_message.cancel);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: speed_up
  {
    size_t item_size = sizeof(ros_message.speed_up);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: slow_down
  {
    size_t item_size = sizeof(ros_message.slow_down);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: further
  {
    size_t item_size = sizeof(ros_message.further);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: closer
  {
    size_t item_size = sizeof(ros_message.closer);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
max_serialized_size_AdaptiveCruiseControlCommand(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: header
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        std_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Header(
        full_bounded, current_alignment);
    }
  }

  // Member: msg_counter
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: set_speed
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: set
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  // Member: resume
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  // Member: cancel
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  // Member: speed_up
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  // Member: slow_down
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  // Member: further
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  // Member: closer
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  return current_alignment - initial_alignment;
}

static bool _AdaptiveCruiseControlCommand__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const automotive_platform_msgs::msg::AdaptiveCruiseControlCommand *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _AdaptiveCruiseControlCommand__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _AdaptiveCruiseControlCommand__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const automotive_platform_msgs::msg::AdaptiveCruiseControlCommand *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _AdaptiveCruiseControlCommand__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_AdaptiveCruiseControlCommand(full_bounded, 0);
}

static message_type_support_callbacks_t _AdaptiveCruiseControlCommand__callbacks = {
  "automotive_platform_msgs::msg",
  "AdaptiveCruiseControlCommand",
  _AdaptiveCruiseControlCommand__cdr_serialize,
  _AdaptiveCruiseControlCommand__cdr_deserialize,
  _AdaptiveCruiseControlCommand__get_serialized_size,
  _AdaptiveCruiseControlCommand__max_serialized_size
};

static rosidl_message_type_support_t _AdaptiveCruiseControlCommand__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_AdaptiveCruiseControlCommand__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace automotive_platform_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_automotive_platform_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand>()
{
  return &automotive_platform_msgs::msg::typesupport_fastrtps_cpp::_AdaptiveCruiseControlCommand__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, automotive_platform_msgs, msg, AdaptiveCruiseControlCommand)() {
  return &automotive_platform_msgs::msg::typesupport_fastrtps_cpp::_AdaptiveCruiseControlCommand__handle;
}

#ifdef __cplusplus
}
#endif
