// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from automotive_platform_msgs:msg/UserInputMedia.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/detail/user_input_media__rosidl_typesupport_fastrtps_cpp.hpp"
#include "automotive_platform_msgs/msg/detail/user_input_media__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace std_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const std_msgs::msg::Header &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  std_msgs::msg::Header &);
size_t get_serialized_size(
  const std_msgs::msg::Header &,
  size_t current_alignment);
size_t
max_serialized_size_Header(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace std_msgs


namespace automotive_platform_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
cdr_serialize(
  const automotive_platform_msgs::msg::UserInputMedia & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.header,
    cdr);
  // Member: btn_vol_up
  cdr << (ros_message.btn_vol_up ? true : false);
  // Member: btn_vol_down
  cdr << (ros_message.btn_vol_down ? true : false);
  // Member: btn_mute
  cdr << (ros_message.btn_mute ? true : false);
  // Member: btn_next
  cdr << (ros_message.btn_next ? true : false);
  // Member: btn_prev
  cdr << (ros_message.btn_prev ? true : false);
  // Member: btn_next_hang_up
  cdr << (ros_message.btn_next_hang_up ? true : false);
  // Member: btn_prev_answer
  cdr << (ros_message.btn_prev_answer ? true : false);
  // Member: btn_hang_up
  cdr << (ros_message.btn_hang_up ? true : false);
  // Member: btn_answer
  cdr << (ros_message.btn_answer ? true : false);
  // Member: btn_play
  cdr << (ros_message.btn_play ? true : false);
  // Member: btn_pause
  cdr << (ros_message.btn_pause ? true : false);
  // Member: btn_play_pause
  cdr << (ros_message.btn_play_pause ? true : false);
  // Member: btn_mode
  cdr << (ros_message.btn_mode ? true : false);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  automotive_platform_msgs::msg::UserInputMedia & ros_message)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.header);

  // Member: btn_vol_up
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_vol_up = tmp ? true : false;
  }

  // Member: btn_vol_down
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_vol_down = tmp ? true : false;
  }

  // Member: btn_mute
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_mute = tmp ? true : false;
  }

  // Member: btn_next
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_next = tmp ? true : false;
  }

  // Member: btn_prev
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_prev = tmp ? true : false;
  }

  // Member: btn_next_hang_up
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_next_hang_up = tmp ? true : false;
  }

  // Member: btn_prev_answer
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_prev_answer = tmp ? true : false;
  }

  // Member: btn_hang_up
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_hang_up = tmp ? true : false;
  }

  // Member: btn_answer
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_answer = tmp ? true : false;
  }

  // Member: btn_play
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_play = tmp ? true : false;
  }

  // Member: btn_pause
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_pause = tmp ? true : false;
  }

  // Member: btn_play_pause
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_play_pause = tmp ? true : false;
  }

  // Member: btn_mode
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_mode = tmp ? true : false;
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
get_serialized_size(
  const automotive_platform_msgs::msg::UserInputMedia & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: header

  current_alignment +=
    std_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.header, current_alignment);
  // Member: btn_vol_up
  {
    size_t item_size = sizeof(ros_message.btn_vol_up);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_vol_down
  {
    size_t item_size = sizeof(ros_message.btn_vol_down);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_mute
  {
    size_t item_size = sizeof(ros_message.btn_mute);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_next
  {
    size_t item_size = sizeof(ros_message.btn_next);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_prev
  {
    size_t item_size = sizeof(ros_message.btn_prev);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_next_hang_up
  {
    size_t item_size = sizeof(ros_message.btn_next_hang_up);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_prev_answer
  {
    size_t item_size = sizeof(ros_message.btn_prev_answer);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_hang_up
  {
    size_t item_size = sizeof(ros_message.btn_hang_up);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_answer
  {
    size_t item_size = sizeof(ros_message.btn_answer);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_play
  {
    size_t item_size = sizeof(ros_message.btn_play);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_pause
  {
    size_t item_size = sizeof(ros_message.btn_pause);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_play_pause
  {
    size_t item_size = sizeof(ros_message.btn_play_pause);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_mode
  {
    size_t item_size = sizeof(ros_message.btn_mode);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
max_serialized_size_UserInputMedia(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: header
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        std_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Header(
        full_bounded, current_alignment);
    }
  }

  // Member: btn_vol_up
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_vol_down
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_mute
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_next
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_prev
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_next_hang_up
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_prev_answer
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_hang_up
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_answer
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_play
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_pause
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_play_pause
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_mode
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  return current_alignment - initial_alignment;
}

static bool _UserInputMedia__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const automotive_platform_msgs::msg::UserInputMedia *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _UserInputMedia__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<automotive_platform_msgs::msg::UserInputMedia *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _UserInputMedia__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const automotive_platform_msgs::msg::UserInputMedia *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _UserInputMedia__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_UserInputMedia(full_bounded, 0);
}

static message_type_support_callbacks_t _UserInputMedia__callbacks = {
  "automotive_platform_msgs::msg",
  "UserInputMedia",
  _UserInputMedia__cdr_serialize,
  _UserInputMedia__cdr_deserialize,
  _UserInputMedia__get_serialized_size,
  _UserInputMedia__max_serialized_size
};

static rosidl_message_type_support_t _UserInputMedia__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_UserInputMedia__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace automotive_platform_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_automotive_platform_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<automotive_platform_msgs::msg::UserInputMedia>()
{
  return &automotive_platform_msgs::msg::typesupport_fastrtps_cpp::_UserInputMedia__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, automotive_platform_msgs, msg, UserInputMedia)() {
  return &automotive_platform_msgs::msg::typesupport_fastrtps_cpp::_UserInputMedia__handle;
}

#ifdef __cplusplus
}
#endif
