// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from automotive_platform_msgs:msg/CabinReport.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/detail/cabin_report__rosidl_typesupport_fastrtps_cpp.hpp"
#include "automotive_platform_msgs/msg/detail/cabin_report__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace std_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const std_msgs::msg::Header &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  std_msgs::msg::Header &);
size_t get_serialized_size(
  const std_msgs::msg::Header &,
  size_t current_alignment);
size_t
max_serialized_size_Header(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace std_msgs


namespace automotive_platform_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
cdr_serialize(
  const automotive_platform_msgs::msg::CabinReport & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.header,
    cdr);
  // Member: door_open_front_right
  cdr << (ros_message.door_open_front_right ? true : false);
  // Member: door_open_front_left
  cdr << (ros_message.door_open_front_left ? true : false);
  // Member: door_open_rear_right
  cdr << (ros_message.door_open_rear_right ? true : false);
  // Member: door_open_rear_left
  cdr << (ros_message.door_open_rear_left ? true : false);
  // Member: hood_open
  cdr << (ros_message.hood_open ? true : false);
  // Member: trunk_open
  cdr << (ros_message.trunk_open ? true : false);
  // Member: passenger_present
  cdr << (ros_message.passenger_present ? true : false);
  // Member: passenger_airbag_enabled
  cdr << (ros_message.passenger_airbag_enabled ? true : false);
  // Member: seatbelt_engaged_driver
  cdr << (ros_message.seatbelt_engaged_driver ? true : false);
  // Member: seatbelt_engaged_passenger
  cdr << (ros_message.seatbelt_engaged_passenger ? true : false);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  automotive_platform_msgs::msg::CabinReport & ros_message)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.header);

  // Member: door_open_front_right
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.door_open_front_right = tmp ? true : false;
  }

  // Member: door_open_front_left
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.door_open_front_left = tmp ? true : false;
  }

  // Member: door_open_rear_right
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.door_open_rear_right = tmp ? true : false;
  }

  // Member: door_open_rear_left
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.door_open_rear_left = tmp ? true : false;
  }

  // Member: hood_open
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.hood_open = tmp ? true : false;
  }

  // Member: trunk_open
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.trunk_open = tmp ? true : false;
  }

  // Member: passenger_present
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.passenger_present = tmp ? true : false;
  }

  // Member: passenger_airbag_enabled
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.passenger_airbag_enabled = tmp ? true : false;
  }

  // Member: seatbelt_engaged_driver
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.seatbelt_engaged_driver = tmp ? true : false;
  }

  // Member: seatbelt_engaged_passenger
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.seatbelt_engaged_passenger = tmp ? true : false;
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
get_serialized_size(
  const automotive_platform_msgs::msg::CabinReport & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: header

  current_alignment +=
    std_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.header, current_alignment);
  // Member: door_open_front_right
  {
    size_t item_size = sizeof(ros_message.door_open_front_right);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: door_open_front_left
  {
    size_t item_size = sizeof(ros_message.door_open_front_left);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: door_open_rear_right
  {
    size_t item_size = sizeof(ros_message.door_open_rear_right);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: door_open_rear_left
  {
    size_t item_size = sizeof(ros_message.door_open_rear_left);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: hood_open
  {
    size_t item_size = sizeof(ros_message.hood_open);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: trunk_open
  {
    size_t item_size = sizeof(ros_message.trunk_open);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: passenger_present
  {
    size_t item_size = sizeof(ros_message.passenger_present);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: passenger_airbag_enabled
  {
    size_t item_size = sizeof(ros_message.passenger_airbag_enabled);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: seatbelt_engaged_driver
  {
    size_t item_size = sizeof(ros_message.seatbelt_engaged_driver);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: seatbelt_engaged_passenger
  {
    size_t item_size = sizeof(ros_message.seatbelt_engaged_passenger);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_platform_msgs
max_serialized_size_CabinReport(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: header
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        std_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Header(
        full_bounded, current_alignment);
    }
  }

  // Member: door_open_front_right
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: door_open_front_left
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: door_open_rear_right
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: door_open_rear_left
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: hood_open
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: trunk_open
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: passenger_present
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: passenger_airbag_enabled
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: seatbelt_engaged_driver
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: seatbelt_engaged_passenger
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  return current_alignment - initial_alignment;
}

static bool _CabinReport__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const automotive_platform_msgs::msg::CabinReport *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _CabinReport__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<automotive_platform_msgs::msg::CabinReport *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _CabinReport__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const automotive_platform_msgs::msg::CabinReport *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _CabinReport__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_CabinReport(full_bounded, 0);
}

static message_type_support_callbacks_t _CabinReport__callbacks = {
  "automotive_platform_msgs::msg",
  "CabinReport",
  _CabinReport__cdr_serialize,
  _CabinReport__cdr_deserialize,
  _CabinReport__get_serialized_size,
  _CabinReport__max_serialized_size
};

static rosidl_message_type_support_t _CabinReport__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_CabinReport__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace automotive_platform_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_automotive_platform_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<automotive_platform_msgs::msg::CabinReport>()
{
  return &automotive_platform_msgs::msg::typesupport_fastrtps_cpp::_CabinReport__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, automotive_platform_msgs, msg, CabinReport)() {
  return &automotive_platform_msgs::msg::typesupport_fastrtps_cpp::_CabinReport__handle;
}

#ifdef __cplusplus
}
#endif
